//
ui.uiSystem<-ui.UISystem.get();
ui.root<- ui.uiSystem.root();

m_bkg <- ui.FilledRectControl.createColored(gfx.Color.createRGB(192,192,192));
ui.root.addChild(m_bkg, -1);

m_scrollbox <-ui.TransparentControl.create();
ui.root.addChild(m_scrollbox, -1);

m_scrollarea <-ui.TransparentControl.create();
m_scrollbox.addChild(m_scrollarea, -1);

actionMenuFlags <- {
};

m_scrollUnderRight <- ui.FramedRectControl.createColored(gfx.Color.createRGB(255,255,255));
m_scrollbox.addChild(m_scrollUnderRight, -1);
m_scrollCtrlRight <- ui.ScriptScrollerControl.create(ui.FilledRectControl.createColored(gfx.Color.createRGB(255,255,255)));
m_scrollUnderRight.addChild(m_scrollCtrlRight, -1);
m_scrollCtrlRight.scriptEventOnScroll().setHandler(
    function (x,y) 
    {
//        sounds.scroll_down.playOnce();
        m_playfield.setPosition(-m_scrollCtrlDown.getPositionX(),-m_scrollCtrlRight.getPositionY());
        actionMenu.adjustVisuality();
    }
);

m_scrollUnderDown <- ui.FramedRectControl.createColored(gfx.Color.createRGB(255,255,255));
m_scrollbox.addChild(m_scrollUnderDown, -1);
m_scrollCtrlDown <- ui.ScriptScrollerControl.create(ui.FilledRectControl.createColored(gfx.Color.createRGB(255,255,255)));
m_scrollUnderDown.addChild(m_scrollCtrlDown, -1);
m_scrollCtrlDown.scriptEventOnScroll().setHandler(
    function (x,y) 
    {
//        sounds.scroll_up.playOnce();
        m_playfield.setPosition(-m_scrollCtrlDown.getPositionX(),-m_scrollCtrlRight.getPositionY());
        actionMenu.adjustVisuality();
    }
);

m_playfield <-ui.TransparentControl.create();
m_scrollarea.addChild(m_playfield, -1);
m_mouse<-ui.ScriptMouseControl.create();
m_playfield.addChild(m_mouse,-1);

m_mouse.scriptEventOnMouseButton().setHandler(
    function (x,y,btn,pressed)  
    {
        if(m_gameParams.in_game == true) {
            if(btn == 0) {
                if(pressed == true) {
                    m_cells[(x / 16) + (y / 16) * m_gameParams.x_cells ].processMouseClick();
                }
            }
        }
    }
);

m_gameParams <- {
    x_cells = 0,
    y_cells = 0,
    bombs   = 0,
    field_offset_x = 0,
    field_offset_y = 0,
    currentCell = null,
    in_game = false,
    left_undiged = 0,
    flags_marked = 0,
    timeGone = 0,
    level = -1
};

function resize(x,y,w,h) 
{
    local playWidth = m_gameParams.x_cells * 16;
    local playHeight = m_gameParams.y_cells * 16;
    m_playfield.setRect(0, 0, playWidth, playHeight);
    m_mouse.setRect(0, 0, playWidth, playHeight);
    local xExt = 0;
    local yExt = 0;
    if(w > h) {
        xExt = 32;
    } else {
        yExt = 32;
    }
    local scrollWidth = playWidth + 16 + xExt; 
    local scrollHeight = playHeight + 16 + yExt;
    local scrollLeft = (w - scrollWidth) / 2;
    local scrollTop = (h - scrollHeight) / 2;
    if(scrollLeft < 0) {
        scrollLeft = xExt;
        scrollWidth = w-xExt;
    } else {
        scrollLeft += xExt;
        scrollWidth -= xExt;
    }
    if(scrollTop < 0) {
        scrollTop = yExt;
        scrollHeight = h-yExt;
    } else {
        scrollTop += yExt;
        scrollHeight -= yExt;
    }
    m_scrollbox.setRect(scrollLeft, scrollTop, scrollWidth, scrollHeight);
    m_scrollarea.setRect(0,0,scrollWidth-16, scrollHeight-16);
    m_scrollUnderRight.setRect(scrollWidth-15,1,14,scrollHeight-17);
    m_scrollUnderDown.setRect(1,scrollHeight-15,scrollWidth-17,14);
    m_scrollCtrlRight.setRect(2,2,10,scrollHeight-21);
    m_scrollCtrlDown.setRect(2,2,scrollWidth-21,10);
    m_scrollCtrlRight.setElementsSizes(1, playHeight, 1, scrollHeight-16);
    m_scrollCtrlDown.setElementsSizes(playWidth, 1, scrollWidth-16, 1);
    m_gameParams.field_offset_x = scrollLeft
    m_gameParams.field_offset_y = scrollTop;
    m_bkg.setRect(0,0,w,h);
    m_playfield.setPosition(-m_scrollCtrlDown.getPositionX(),-m_scrollCtrlRight.getPositionY());
    actionMenu.adjustVisuality();
    
    if(xExt > 0) {
        //vertical bar
        local yOffs = (h - (flagsLeft.root.getHeight() + m_restart.getHeight() + timer.getHeight())) / 2;
        flagsLeft.root.setPosition(scrollLeft-flagsLeft.root.getWidth(),yOffs);
        m_restart.setPosition(scrollLeft-m_restart.getWidth(),yOffs+flagsLeft.root.getHeight());
        timer.setPosition(scrollLeft-m_restart.getWidth(),yOffs+flagsLeft.root.getHeight()+m_restart.getHeight());
    } else {
        //horizontal bar
        local xOffs = (w - (flagsLeft.root.getWidth() + m_restart.getWidth() + timer.getWidth())) / 2;
        flagsLeft.root.setPosition(xOffs,scrollTop-flagsLeft.root.getHeight());
        m_restart.setPosition(xOffs+flagsLeft.root.getWidth(),scrollTop-m_restart.getHeight());
        timer.setPosition(xOffs+flagsLeft.root.getWidth()+m_restart.getWidth(),scrollTop-m_restart.getHeight());
    }
    
    mainMenu.resize();
}

function markBomb()
{
    ++m_gameParams.flags_marked; 
    flagsLeft.setValue(m_gameParams.bombs - m_gameParams.flags_marked);
    checkVictory();
}

function unmarkBomb()
{
    --m_gameParams.flags_marked;
    flagsLeft.setValue(m_gameParams.bombs - m_gameParams.flags_marked);
    checkVictory();
}

function checkVictory()
{
    if((m_gameParams.left_undiged <= 0)&&(m_gameParams.flags_marked == m_gameParams.bombs)) {
        m_gameParams.in_game = false;
        snd.SamplePlayer.get().playSample("sounds/win.ogg");
        youWin.setVisible(true);

        xscores.setTime(m_gameParams.level, m_gameParams.timeGone);
    }
}

ui.root.scriptEventRectChanged().setHandler( resize );

function newGame(xcells, ycells, bombs, level) 
{
        m_gameParams.level = level;

        local newImages = xcells*ycells;
        local oldImages = m_gameParams.x_cells*m_gameParams.y_cells;

    for(local i=newImages; i<oldImages; ++i) {
        m_playfield.removeChild(m_images[i]);
                m_images[i] = null;   
    }

    m_gameParams.x_cells = xcells;
    m_gameParams.y_cells = ycells;
    m_gameParams.bombs = bombs;
    m_gameParams.in_game = true;
    m_gameParams.left_undiged = xcells*ycells - bombs;
    m_gameParams.flags_marked = 0;
    
    for(local i=oldImages; i<newImages; ++i) {
                local newImage = ui.ImageControl.createFromFile("minesweeper.png");  
        m_playfield.addChild(newImage, 0);
        m_images[i]=newImage;  
    }
    
    for(local y=0; y<ycells; ++y) {
        actionMenuFlags[y] <-{};
        for(local x=0; x<xcells; ++x) {
            local newImage = m_images[x + (y*xcells)];
            newImage.setRect(x*16, y*16, 16, 16);
            newImage.setImageRect(m_rects.raw);
            m_cells[x+(y*xcells)].reset(x,y);
            actionMenuFlags[y][x] <-{};            
            actionMenuFlags[y][x].flag_added <-false;
            actionMenuFlags[y][x].q_added <-false;
        }
    }
    
    local incNearBombs = function(x,y) 
    { 
        if((x >= 0)&&(x < m_gameParams.x_cells)&&(y >= 0)&&(y < m_gameParams.y_cells)) {
            ++m_cells[x + y*m_gameParams.x_cells]._nearBombs;
        }
    };

    local bombsDone = 0;
    while(bombsDone < bombs) {
        local xr = math.random.intFromRange(0, xcells-1);
        local yr = math.random.intFromRange(0, ycells-1);
        local cell = m_cells[xr + yr*xcells];

        if(cell._isBomb == false) {
            cell._isBomb = true;
            incNearBombs(xr-1, yr-1);
            incNearBombs(xr-1, yr);
            incNearBombs(xr-1, yr+1);
            incNearBombs(xr+1, yr-1);
            incNearBombs(xr+1, yr);
            incNearBombs(xr+1, yr+1);
            incNearBombs(xr, yr-1);
            incNearBombs(xr, yr+1);

            ++bombsDone;
        }
    }

    actionMenu.hideAfterNewGame();
    flagsLeft.setValue(m_gameParams.bombs - m_gameParams.flags_marked);
    youWin.setVisible(false);
    youLose.setVisible(false);
    resize(0,0,ui.root.getWidth(),ui.root.getHeight());

        xscores.restart();
}

class CMyCell{
    function reset(x,y)
    {
        _isBomb = false;
        _state = "raw";
        _nearBombs = 0;
        _isDiged = false;
        _x = x;
        _y = y;
    }

    function processMouseClick()
    {
        if(_isDiged == false) {
            m_gameParams.currentCell = this;
            actionMenu.showForCell(_x, _y);
        }
    }

    function performDig()
    {
        _isDiged = true;
        if(_state == "flag") {
            unmarkBomb();
        }

        if (_isBomb) {
            for(local i=0; i<m_gameParams.y_cells * m_gameParams.x_cells; ++i) {
                m_cells[i].discoverOnDeath();
            }
            setMyImage("ups");
            m_gameParams.in_game = false;
            youLose.setVisible(true);
            snd.SamplePlayer.get().playSample("sounds/game_over.ogg");
        }
        else
        {
            uncoverNear();
        }
    }

    function performSuggest()
    {
        if (_state != "flag") {
            if(m_gameParams.bombs - m_gameParams.flags_marked > 0) {
                _state = "flag";
                markBomb();
            } else {
                performQuestion();
            }
        } else {
            _state ="raw";
            unmarkBomb();
        }
        setMyImage(_state);
    }

    function performQuestion()
    { 
        if (_state != "hz") {
            if(_state == "flag") {
                unmarkBomb();
            }
            _state = "hz";
        } else
            _state ="raw";
        setMyImage(_state);
    }

    function setMyImage(name)
    {
        m_images[_x + _y*m_gameParams.x_cells].setImageRect(m_rects[name]);
    }

    function discoverOnDeath()
    {
        if(_isBomb) {
            if(_state != "flag") {
                setMyImage("bomb"); 
            }
        } else {
            if(_state == "flag") {
                setMyImage("missed");
            }
        }
    }

    function uncoverNear()
    {
        _isDiged = true;
        --m_gameParams.left_undiged;
        if (_state == "flag") {
            _state ="raw";
            unmarkBomb();
        }        
        checkVictory();
        if(_nearBombs == 0) {
            uncoverOne(_x - 1, _y - 1);
            uncoverOne(_x - 1, _y);
            uncoverOne(_x - 1, _y + 1);
            uncoverOne(_x + 1, _y - 1);
            uncoverOne(_x + 1, _y);
            uncoverOne(_x + 1, _y + 1);
            uncoverOne(_x, _y - 1);
            uncoverOne(_x, _y + 1);
            _state = "empty";
        } else {
            _state = "b"+_nearBombs;
        }
        setMyImage(_state);
    }

    function uncoverOne(x,y) 
    {
        if((x>=0) && (y>=0) && (x<m_gameParams.x_cells) && (y<m_gameParams.y_cells)) {
            local cell = m_cells[x + y*m_gameParams.x_cells];
            if(cell._isDiged == false) {
                cell.uncoverNear(); 
            }
        }
    }

    _isBomb = false;
    _state = "raw";
    _x = 0;
    _y = 0;
    _nearBombs = 0;
    _isDiged = false;
}

m_images <- [];
m_cells <- [];
for(local ii=0;ii<1600;++ii) {
        m_images.append(null);
        m_cells.append(CMyCell());
}

m_rects <- {
    b1      = gfx.Rect.createXYWH(0.0,      0.0, 16.0, 16.0),
    b2      = gfx.Rect.createXYWH(16.0,     0.0, 16.0, 16.0),
    b3      = gfx.Rect.createXYWH(32.0,     0.0, 16.0, 16.0),
    b4      = gfx.Rect.createXYWH(48.0,     0.0, 16.0, 16.0),
    b5      = gfx.Rect.createXYWH(0.0,      16.0, 16.0, 16.0),
    b6      = gfx.Rect.createXYWH(16.0,     16.0, 16.0, 16.0),
    b7      = gfx.Rect.createXYWH(32.0,     16.0, 16.0, 16.0),
    b8      = gfx.Rect.createXYWH(48.0,     16.0, 16.0, 16.0),
    raw     = gfx.Rect.createXYWH(0.0,      32.0, 16.0, 16.0),
    empty   = gfx.Rect.createXYWH(16.0,     32.0, 16.0, 16.0),
    flag    = gfx.Rect.createXYWH(32.0,     32.0, 16.0, 16.0),
    missed  = gfx.Rect.createXYWH(48.0,     32.0, 16.0, 16.0),
    bomb    = gfx.Rect.createXYWH(0.0,      48.0, 16.0, 16.0),
    ups     = gfx.Rect.createXYWH(16.0,     48.0, 16.0, 16.0),
    hz      = gfx.Rect.createXYWH(32.0,     48.0, 16.0, 16.0),

    im_dig      = gfx.Rect.createXYWH(0.0,  0.0, 32.0, 32.0),
    im_suggest  = gfx.Rect.createXYWH(0.0, 32.0, 32.0, 32.0),
    im_question = gfx.Rect.createXYWH(32.0,  0.0, 32.0, 32.0),
    im_close    = gfx.Rect.createXYWH(32.0,  32.0, 32.0, 32.0),
    
    counter_bkg = gfx.Rect.createXYWH(96.0,  0.0, 32.0, 32.0),
    counter_0   = gfx.Rect.createXYWH(9.0 * 0, 0.0, 9.0, 26.0),
    counter_1   = gfx.Rect.createXYWH(9.0 * 1, 0.0, 9.0, 26.0),
    counter_2   = gfx.Rect.createXYWH(9.0 * 2, 0.0, 9.0, 26.0),
    counter_3   = gfx.Rect.createXYWH(9.0 * 3, 0.0, 9.0, 26.0),
    counter_4   = gfx.Rect.createXYWH(9.0 * 4, 0.0, 9.0, 26.0),
    counter_5   = gfx.Rect.createXYWH(9.0 * 5, 0.0, 9.0, 26.0),
    counter_6   = gfx.Rect.createXYWH(9.0 * 6, 0.0, 9.0, 26.0),
    counter_7   = gfx.Rect.createXYWH(9.0 * 7, 0.0, 9.0, 26.0),
    counter_8   = gfx.Rect.createXYWH(9.0 * 8, 0.0, 9.0, 26.0),
    counter_9   = gfx.Rect.createXYWH(9.0 * 9, 0.0, 9.0, 26.0),
    
    youWin   = gfx.Rect.createXYWH(0.0, 0.0, 32.0, 32.0),
    youLose  = gfx.Rect.createXYWH(32.0, 0.0, 32.0, 32.0),
}

script.vm.executeFile("scripts\\minesweeper_counter.nut");

flagsLeft <- Counter("minesweeper_counter.png");
ui.root.addChild(flagsLeft.root,-1);

youWin <- ui.ImageControl.createFromFileRected("minesweeper_winlose.png", m_rects.youWin);
youLose <- ui.ImageControl.createFromFileRected("minesweeper_winlose.png", m_rects.youLose);
youWin.setRect(0,0,32,32);
youLose.setRect(0,0,32,32);
flagsLeft.root.addChild(youWin,-1);
flagsLeft.root.addChild(youLose,-1);

    m_restart <- ui.ScriptButtonControl.create2Stated(
        ui.ImageControl.createFromFileRected("minesweeper_mainbutton.png", gfx.Rect.createXYWH(0.0, 0.0, 32.0, 32.0)),
        ui.ImageControl.createFromFileRected("minesweeper_mainbutton.png", gfx.Rect.createXYWH(32.0, 0.0, 32.0, 32.0))
    );
    
    timer <- ui.ImageControl.createFromFileRected("minesweeper_counter.png", m_rects.counter_bkg);
    timer.setSize(32,32);

    m_restart.setSize(32,32);
    ui.root.addChild(m_restart,-1);
    ui.root.addChild(timer, -1);

    m_restart.scriptEventOnClick().setHandler(
        function()
        {
                if(("mainButtonClick" in sounds) == false) {
                                sounds.mainButtonClick <- snd.SoundSystem.get().createSoundFX(
                                        snd.SoundSystem.get().loadSoundSample("sounds/back_to_main_1.ogg")     
                                );
                        }
                        sounds.mainButtonClick.playOnce();
            mainMenu.show();
        }
    );

script.vm.executeFile("scripts\\minesweeper_action_menu.nut");

script.vm.executeFile("scripts\\minesweeper_mainmenu.nut");

script.vm.executeFile("scripts\\minesweeper_scores.nut");

sounds <- {};

sounds.popup <- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/dig_popup.ogg")       
);

sounds.popup_remove <- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/dig_popup_1.ogg")       
);

sounds.mainMenuClick <- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/menu_click_back.ogg")       
);                                                               

sounds.flag_add<- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/dig_flag.ogg")        
);

sounds.flag_remove<- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/dig_flag_remove.ogg")        
);

sounds.q_add<- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/dig_q.ogg")        
);

sounds.q_remove<- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/dig_q_remove.ogg")        
);

//sounds.scroll_up<- snd.SoundSystem.get().createSoundFX(
//        snd.SoundSystem.get().loadSoundSample("sounds/scroll_up.ogg")        
//);

//sounds.scroll_down<- snd.SoundSystem.get().createSoundFX(
//        snd.SoundSystem.get().loadSoundSample("sounds/scroll_down.ogg")        
//);

sounds.dig <- snd.SoundSystem.get().createSoundFX(
        snd.SoundSystem.get().loadSoundSample("sounds/dig_dig.ogg") 
);

sounds.popupLose <- sounds.popup_remove; //snd.SoundSystem.get().createSoundFX(
//        snd.SoundSystem.get().loadSoundSample("sounds/popupLose.ogg")   
//);

mainMenu.updateScores();

mainMenu.show();