//ingame popup action menu

actionMenu <- 
{
    logic_x = -1,
    logic_y = -1
};

//methods


actionMenu.showForCell <- function (cellX, cellY)
{
        sounds.popup.playOnce();
    logic_x = cellX;
    logic_y = cellY;
    redFrame.setVisible(true);
    blueFrame.setVisible(true);
    btnDig.setVisible(true);
    btnSuggest.setVisible(true);
    btnQuestion.setVisible(true);
    btnClose.setVisible(true);
    adjustVisuality();
}

actionMenu.adjustVisuality <- function()
{
    if(btnDig.getVisible() == false) {
        return;
    }
    local cellLeft   = m_playfield.getLeft() + logic_x*16;
    local cellTop    = m_playfield.getTop() + logic_y*16;
    local cellRight  = cellLeft + 15;
    local cellBottom = cellTop + 15;
    if(
        (cellLeft < -4)||
        (cellTop < -4)||
        (cellRight>m_scrollarea.getWidth()+4)||
        (cellBottom>m_scrollarea.getHeight()+4)) {
        hideAfterOffscreen();
        return;
    }
    local xPos = m_gameParams.field_offset_x + cellLeft - 44;
    local yPos = m_gameParams.field_offset_y + cellTop - 44;
    redFrame.setRect(xPos+41,yPos+41,21,21);
    blueFrame.setRect(xPos+28,yPos+28,48,48);
    
    local layoutname = "center";
    
    if(xPos < -8) {
        if(yPos < -8) {
            layoutname = "left_up";
        } else if(yPos > ui.root.getHeight() - 96) {
            layoutname = "left_down";
        } else {
            layoutname = "left";
        }    
    } else if(xPos > ui.root.getWidth() - 96) {
        if(yPos < -8) {
            layoutname = "right_up";
        } else if(yPos > ui.root.getHeight() - 96) {
            layoutname = "right_down";
        } else {
            layoutname = "right";
        }
    } else {
        if(yPos < -8) {
            layoutname = "up";
        } else if(yPos > ui.root.getHeight() - 96) {
            layoutname = "down";
        } else {
            layoutname = "center";
        }
    }
    
    local layout = layouts[layoutname];
    
    btnDig.setRect(xPos+layout.btnDig[0], yPos+layout.btnDig[1], 32, 32);
    btnSuggest.setRect(xPos+layout.btnSuggest[0], yPos+layout.btnSuggest[1], 32, 32);
    btnQuestion.setRect(xPos+layout.btnQuestion[0], yPos+layout.btnQuestion[1], 32, 32);
    btnClose.setRect(xPos+layout.btnClose[0], yPos+layout.btnClose[1], 32, 32);
}

actionMenu.layouts <- 
{
    center = {
        btnDig = [0,36],
        btnSuggest = [72,36],
        btnQuestion = [36,72],
        btnClose = [36,0]
    },
    
    left = {
        btnDig = [72,36],
        btnSuggest = [104,36],
        btnQuestion = [36,72],
        btnClose = [36,0]
    },
    
    left_down = {
        btnDig = [72,36],
        btnSuggest = [104,36],
        btnQuestion = [36,0],
        btnClose = [36,-32]
    },
    
    left_up = {
        btnDig = [72,36],
        btnSuggest = [104,36],
        btnQuestion = [36,104],
        btnClose = [36,72]
    },
    
    right = {
        btnDig = [-32,36],
        btnSuggest = [0,36],
        btnQuestion = [36,72],
        btnClose = [36,0]
    },
    
    right_down = {
        btnDig = [-32,36],
        btnSuggest = [0,36],
        btnQuestion = [36,0],
        btnClose = [36,-32]
    },
    
    right_up = {
        btnDig = [-32,36],
        btnSuggest = [0,36],
        btnQuestion = [36,104],
        btnClose = [36,72]
    },
    
    up = {
        btnDig = [0,36],
        btnSuggest = [72,36],
        btnQuestion = [36,104],
        btnClose = [36,72]
    },
    
    down = {
        btnDig = [0,36],
        btnSuggest = [72,36],
        btnQuestion = [36,0],
        btnClose = [36,-32]
    }
};

actionMenu.hideAfterClick <- function ()
{
    hideAfterNewGame();
}

actionMenu.hideAfterNewGame <- function ()
{
    redFrame.setVisible(false);
    blueFrame.setVisible(false);
    btnDig.setVisible(false);
    btnSuggest.setVisible(false);
    btnQuestion.setVisible(false);
    btnClose.setVisible(false);
}

actionMenu.hideAfterOffscreen <- function ()
{
        sounds.popupLose.playOnce();
    hideAfterNewGame();
}

//creating buttons

actionMenu.btnDig <- ui.ScriptButtonControl.create2Stated(
        ui.ImageControl.createFromFileRected("minesweeper_ingame_raised.png", m_rects.im_dig),
        ui.ImageControl.createFromFileRected("minesweeper_ingame_lowered.png", m_rects.im_dig)
    );

actionMenu.btnSuggest <- ui.ScriptButtonControl.create2Stated(
        ui.ImageControl.createFromFileRected("minesweeper_ingame_raised.png", m_rects.im_suggest),
        ui.ImageControl.createFromFileRected("minesweeper_ingame_lowered.png", m_rects.im_suggest)
    );

actionMenu.btnQuestion <-  ui.ScriptButtonControl.create2Stated(
        ui.ImageControl.createFromFileRected("minesweeper_ingame_raised.png",m_rects.im_question),
        ui.ImageControl.createFromFileRected("minesweeper_ingame_lowered.png", m_rects.im_question)
    );

actionMenu.btnClose <- ui.ScriptButtonControl.create2Stated(
        ui.ImageControl.createFromFileRected("minesweeper_ingame_raised.png", m_rects.im_close),
        ui.ImageControl.createFromFileRected("minesweeper_ingame_lowered.png", m_rects.im_close)
    );

//assigning events

actionMenu.btnDig.scriptEventOnClick().setHandler(
        function()
        {
            sounds.dig.playOnce();
            m_gameParams.currentCell.performDig();
            actionMenu.hideAfterClick();
        }
    );

actionMenu.btnSuggest.scriptEventOnClick().setHandler(
        function()
        {

            if (actionMenuFlags[actionMenu.logic_x][actionMenu.logic_y].flag_added == false) {
                actionMenuFlags[actionMenu.logic_x][actionMenu.logic_y].flag_added = true;
                sounds.flag_add.playOnce();
                }
             else{
                 actionMenuFlags[actionMenu.logic_x][actionMenu.logic_y].flag_added = false;
                 sounds.flag_remove.playOnce();
                }
            m_gameParams.currentCell.performSuggest();
            actionMenu.hideAfterClick();
        }
    );

actionMenu.btnQuestion.scriptEventOnClick().setHandler(
        function()
        {
            if (actionMenuFlags[actionMenu.logic_x][actionMenu.logic_y].q_added == false) {
                actionMenuFlags[actionMenu.logic_x][actionMenu.logic_y].q_added = true;
                sounds.q_add.playOnce();
                }
             else{
                 actionMenuFlags[actionMenu.logic_x][actionMenu.logic_y].q_added = false;
                 sounds.q_remove.playOnce();
                }

            m_gameParams.currentCell.performQuestion();
            actionMenu.hideAfterClick();
        }
    );

actionMenu.btnClose.scriptEventOnClick().setHandler(
        function()
        {
            sounds.popup_remove.playOnce();
            actionMenu.hideAfterClick();
        }
    );

actionMenu.redFrame <- ui.FramedRectControl.createColoredThick(gfx.Color.createRGB(255,0,0), 1);
ui.root.addChild(actionMenu.redFrame,-1);

actionMenu.blueFrame <- ui.FramedRectControl.createColoredThick(gfx.Color.createRGB(255,255,255), 3);
ui.root.addChild(actionMenu.blueFrame,-1);
{
    local frame = ui.FramedRectControl.createColoredThick(gfx.Color.createRGB(0,0,255), 1);
    actionMenu.blueFrame.addChild(frame, -1);
    frame.setRect(1,1,46,46);
}

ui.root.addChild(actionMenu.btnDig, -1);
ui.root.addChild(actionMenu.btnSuggest, -1);
ui.root.addChild(actionMenu.btnQuestion, -1);
ui.root.addChild(actionMenu.btnClose, -1);
actionMenu.btnDig.setSize(32,32);
actionMenu.btnSuggest.setSize(32,32);
actionMenu.btnQuestion.setSize(32,32);
actionMenu.btnClose.setSize(32,32);

actionMenu.hideAfterNewGame();

