//
mainMenu <- {
};

mainMenu.root <- ui.FilledRectControl.createColored(gfx.Color.createRGB(255,255,255));
mainMenu.image <- ui.ImageControl.createFromFileRected("back.png", gfx.Rect.createXYWH(0.0, 0.0, 240.0, 240.0));
mainMenu.rectUp <- gfx.Rect.createXYWH(0.0,0.0,128.0,24.0);
mainMenu.rectDown <- gfx.Rect.createXYWH(0.0,24.0,128.0,24.0);

mainMenu.textEasy <- "Easy";
mainMenu.textNormal <- "Normal";
mainMenu.textHard <- "Hard";
mainMenu.textExtreme <- "Extreme";
mainMenu.textScores <- "Best Times";
mainMenu.textExit <- "Exit";
mainMenu.textBack <- "Back";
mainMenu.textOk <- "Ok";

mainMenu.levels <- [mainMenu.textEasy, mainMenu.textNormal, mainMenu.textHard, mainMenu.textExtreme];

mainMenu.createButtonWithText <- function(text)
{
        local text1 = ui.TextControl.createWithText("console8x8", text);
        local text2 = ui.TextControl.createWithText("console8x8", text);
        local color = gfx.Color.createRGB(255,255,255);
        text1.setTextColor(color);
        text2.setTextColor(color);
        local imageUp = ui.ImageControl.createFromFileRected("menuitem.png", mainMenu.rectUp);
        local imageDown = ui.ImageControl.createFromFileRected("menuitem.png", mainMenu.rectDown);
        imageUp.addChild(text1, -1);
        imageDown.addChild(text2, -1);
        text1.setRect(0,0,128,24);
        text2.setRect(0,0,128,24);
        local result = ui.ScriptButtonControl.create2Stated(imageUp, imageDown);
        return result;
}

mainMenu.image.setRect(0,0,240,240);
mainMenu.root.addChild(mainMenu.image, -1);
ui.root.addChild(mainMenu.root, -1);

{
        local versionText = ui.TextControl.createWithText("console8x8", version);
        mainMenu.image.addChild(versionText, -1);
        versionText.setTextVerticalAlignment(1);
        versionText.setTextHorizontalAlignment(1);
        versionText.setRect(0,0,240,240);
}

mainMenu.show <- function()
{
        mainMenu.root.setVisible(true);
        m_bkg.setVisible(false);
        m_scrollbox.setVisible(false);
        mainMenu.modeMain.setVisible(true);
        mainMenu.modeScores.setVisible(false);
        mainMenu.modeHiScores.setVisible(false);
}

mainMenu.showHiScore <- function(level, time)
{
        mainMenu.show();
        mainMenu.modeMain.setVisible(false);
        mainMenu.modeScores.setVisible(false);
        mainMenu.modeHiScores.setVisible(true);

        mainMenu.hiScoreText.setText(mainMenu.levels[level] + "\n---\n\nBest time!\n\n" + time.tostring() + " seconds");
}

mainMenu.hide <- function()
{
        sounds.mainMenuClick.playOnce();
        mainMenu.root.setVisible(false);
        m_bkg.setVisible(true);
        m_scrollbox.setVisible(true);
}

mainMenu.resize <- function() 
{
        mainMenu.root.setRect(0,0,ui.root.getWidth(),ui.root.getHeight());
        mainMenu.image.setPosition((ui.root.getWidth()-240)/2,(ui.root.getHeight()-240)/2);
};

mainMenu.easy <- mainMenu.createButtonWithText(mainMenu.textEasy);
mainMenu.easy.setRect(56,52,128,24);
mainMenu.easy.scriptEventOnClick().setHandler(
        function() {
                newGame(9,9,10,0);
                mainMenu.hide();
        }
);
mainMenu.medium <- mainMenu.createButtonWithText(mainMenu.textNormal);
mainMenu.medium.setRect(56,76,128,24);
mainMenu.medium.scriptEventOnClick().setHandler(
        function() {
                newGame(16,16,40,1);
                mainMenu.hide();
        }
);
mainMenu.hard <- mainMenu.createButtonWithText(mainMenu.textHard);
mainMenu.hard.setRect(56,100,128,24);
mainMenu.hard.scriptEventOnClick().setHandler(
        function() {
                newGame(30,16,99,2);
                mainMenu.hide();
        }
);
mainMenu.extreme <- mainMenu.createButtonWithText(mainMenu.textExtreme);
mainMenu.extreme.setRect(56,124,128,24);
mainMenu.extreme.scriptEventOnClick().setHandler(
        function() {
                newGame(40,40,256,3);
                mainMenu.hide();
        }
);
mainMenu.scores <- mainMenu.createButtonWithText(mainMenu.textScores);
mainMenu.scores.setRect(56,148,128,24);
mainMenu.scores.scriptEventOnClick().setHandler(
        function() {
                sounds.mainMenuClick.playOnce();
                mainMenu.modeMain.setVisible(false);
                mainMenu.modeScores.setVisible(true);
                mainMenu.modeHiScores.setVisible(false);
        }
);
mainMenu.quit <- mainMenu.createButtonWithText(mainMenu.textExit);
mainMenu.quit.setRect(56,172,128,24);
mainMenu.quit.scriptEventOnClick().setHandler(
        function() {
                core.Core.get().exit();
        }
);

mainMenu.modeMain <- ui.TransparentControl.create();
mainMenu.modeMain.setRect(0,0,240,240);
mainMenu.image.addChild(mainMenu.modeMain, -1);
mainMenu.modeMain.addChild(mainMenu.easy,-1);
mainMenu.modeMain.addChild(mainMenu.medium,-1);
mainMenu.modeMain.addChild(mainMenu.hard,-1);
mainMenu.modeMain.addChild(mainMenu.extreme,-1);
mainMenu.modeMain.addChild(mainMenu.scores,-1);
mainMenu.modeMain.addChild(mainMenu.quit,-1);

mainMenu.modeScores<- ui.TransparentControl.create();
mainMenu.modeScores.setRect(0,0,240,240);
mainMenu.image.addChild(mainMenu.modeScores, -1);

mainMenu.back <- mainMenu.createButtonWithText(mainMenu.textBack);
mainMenu.back.setRect(56,172,128,24);
mainMenu.back.scriptEventOnClick().setHandler(
        function() {
                sounds.mainMenuClick.playOnce();
                mainMenu.modeMain.setVisible(true);
                mainMenu.modeScores.setVisible(false);
                mainMenu.modeHiScores.setVisible(false);
        }
);
mainMenu.modeScores.addChild(mainMenu.back,-1);
{
        local bkg = ui.FilledRectControl.create();
        mainMenu.modeScores.addChild(bkg, -1);  
        bkg.setRect(48,48,144,112);

        mainMenu.bestScores <- ui.TextControl.createWithText("console8x8", "under construction");
        mainMenu.bestScores.setRect(0,0,144,112);
        bkg.addChild(mainMenu.bestScores, -1);
}

mainMenu.updateScores <- function()
{
        mainMenu.bestScores.setText
                (mainMenu.textScores + "\n" 
             + "\n\n" + mainMenu.textEasy + ": " + xscores.times[0].tostring()
             + "\n\n" + mainMenu.textNormal + ": " + xscores.times[1].tostring()
             + "\n\n" + mainMenu.textHard + ": " + xscores.times[2].tostring()
             + "\n\n" + mainMenu.textExtreme + ": " + xscores.times[3].tostring()
            );
}

mainMenu.modeHiScores<- ui.TransparentControl.create();
mainMenu.modeHiScores.setRect(0,0,240,240);
mainMenu.image.addChild(mainMenu.modeHiScores, -1);
mainMenu.hiScoreOk <- mainMenu.createButtonWithText(mainMenu.textOk);
mainMenu.hiScoreOk.setRect(56,172,128,24);
mainMenu.hiScoreOk.scriptEventOnClick().setHandler(
        function() {
                sounds.mainMenuClick.playOnce();
                mainMenu.modeMain.setVisible(true);
                mainMenu.modeScores.setVisible(false);
                mainMenu.modeHiScores.setVisible(false);
        }
);
mainMenu.modeHiScores.addChild(mainMenu.hiScoreOk,-1);
{
        local bkg = ui.FilledRectControl.create();
        mainMenu.modeHiScores.addChild(bkg, -1);        
        bkg.setRect(48,48,144,112);

        mainMenu.hiScoreText <- ui.TextControl.createWithText("console8x8", "under construction");
        mainMenu.hiScoreText.setRect(0,0,144,112);
        bkg.addChild(mainMenu.hiScoreText, -1);
}

mainMenu.resize();
